HitsMode5 = LibStub("AceAddon-3.0"):NewAddon("HitsMode5", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
HitsMode5.MINOR_VERSION = tonumber(("$Revision: 27 $"):match("%d+"))
local L = LibStub("AceLocale-3.0"):GetLocale("HitsMode5")
local HitsMode5 = HitsMode5
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local dataobj = ldb:NewDataObject("HitsMode5", {label = "HitsMode5", type = "data source", icon = "Interface\\Icons\\Ability_CriticalStrike", text = ""})




--[[
      VARIABLES ----------------------------------------------------------------------------------------------------------------
  ]]

local isEnabled = false
local NUM_HELPARTICLES = 1
local filters = {}

HitsMode5.modules = {
	options = {
		loaded = false,
	}
}

local specialEvents = {
	"PLAYER_REGEN_DISABLED",
	"PLAYER_REGEN_ENABLED",
	"CHAT_MSG_COMBAT_XP_GAIN",
	"CHAT_MSG_LOOT",
	"CHAT_MSG_COMBAT_FACTION_CHANGE",
	"CHAT_MSG_COMBAT_HONOR_GAIN",
	"CHAT_MSG_MONEY",
	"CHAT_MSG_SKILL",
}

local DISPLAYMODE_STANDARD = 1
local DISPLAYMODE_STANDARD_NUMBERS_FIRST = 2
local DISPLAYMODE_NUMBERS_ONLY = 3

local formats = {
	[DISPLAYMODE_STANDARD] = "COMBATLOG_FORMAT_STANDARD",
	[DISPLAYMODE_STANDARD_NUMBERS_FIRST] = "COMBATLOG_FORMAT_STANDARD_NUMBERS_FIRST",
	[DISPLAYMODE_NUMBERS_ONLY] = "COMBATLOG_FORMAT_NUMBERS_ONLY",
}

local FLAG_CRITS = 1
local FLAG_HEALS = 2
local FLAG_PET_DAMAGE = 3
local FLAG_ENERGIZES = 4
local FLAG_EXP = 5
local FLAG_HONOR = 6
local FLAG_REP = 7



--[[
      UPVALUES -----------------------------------------------------------------------------------------------------------------
  ]]
  
local _G = getfenv(0)
local bit_bor = _G.bit.bor
local bit_band = _G.bit.band
local tinsert = _G.tinsert
local tremove = _G.tremove
local math_floor = _G.math.floor
local format = _G.format
local gsub = _G.gsub
local strsub = _G.strsub
local strreplace = _G.strreplace
local strsplit = _G.strsplit
local strtrim = _G.strtrim
local strlower = _G.strlower

local CombatLog_Object_IsA = CombatLog_Object_IsA

local COMBATLOG_OBJECT_AFFILIATION_MINE = COMBATLOG_OBJECT_AFFILIATION_MINE
local COMBATLOG_OBJECT_AFFILIATION_PARTY = COMBATLOG_OBJECT_AFFILIATION_PARTY
local COMBATLOG_OBJECT_AFFILIATION_RAID = COMBATLOG_OBJECT_AFFILIATION_RAID
local COMBATLOG_OBJECT_AFFILIATION_OUTSIDER = COMBATLOG_OBJECT_AFFILIATION_OUTSIDER
local COMBATLOG_OBJECT_AFFILIATION_MASK = COMBATLOG_OBJECT_AFFILIATION_MASK
local COMBATLOG_OBJECT_REACTION_FRIENDLY = COMBATLOG_OBJECT_REACTION_FRIENDLY
local COMBATLOG_OBJECT_REACTION_NEUTRAL = COMBATLOG_OBJECT_REACTION_NEUTRAL
local COMBATLOG_OBJECT_REACTION_HOSTILE = COMBATLOG_OBJECT_REACTION_HOSTILE
local COMBATLOG_OBJECT_REACTION_MASK = COMBATLOG_OBJECT_REACTION_MASK
local COMBATLOG_OBJECT_CONTROL_PLAYER = COMBATLOG_OBJECT_CONTROL_PLAYER
local COMBATLOG_OBJECT_CONTROL_NPC = COMBATLOG_OBJECT_CONTROL_NPC
local COMBATLOG_OBJECT_CONTROL_MASK = COMBATLOG_OBJECT_CONTROL_MASK
local COMBATLOG_OBJECT_TYPE_PLAYER = COMBATLOG_OBJECT_TYPE_PLAYER
local COMBATLOG_OBJECT_TYPE_NPC = COMBATLOG_OBJECT_TYPE_NPC
local COMBATLOG_OBJECT_TYPE_PET = COMBATLOG_OBJECT_TYPE_PET
local COMBATLOG_OBJECT_TYPE_GUARDIAN = COMBATLOG_OBJECT_TYPE_GUARDIAN
local COMBATLOG_OBJECT_TYPE_OBJECT = COMBATLOG_OBJECT_TYPE_OBJECT
local COMBATLOG_OBJECT_TYPE_MASK = COMBATLOG_OBJECT_TYPE_MASK
local COMBATLOG_OBJECT_TARGET = COMBATLOG_OBJECT_TARGET
local COMBATLOG_OBJECT_FOCUS = COMBATLOG_OBJECT_FOCUS
local COMBATLOG_OBJECT_MAINTANK = COMBATLOG_OBJECT_MAINTANK
local COMBATLOG_OBJECT_MAINASSIST = COMBATLOG_OBJECT_MAINASSIST
local COMBATLOG_OBJECT_RAIDTARGET1 = COMBATLOG_OBJECT_RAIDTARGET1
local COMBATLOG_OBJECT_RAIDTARGET2 = COMBATLOG_OBJECT_RAIDTARGET2
local COMBATLOG_OBJECT_RAIDTARGET3 = COMBATLOG_OBJECT_RAIDTARGET3
local COMBATLOG_OBJECT_RAIDTARGET4 = COMBATLOG_OBJECT_RAIDTARGET4
local COMBATLOG_OBJECT_RAIDTARGET5 = COMBATLOG_OBJECT_RAIDTARGET5
local COMBATLOG_OBJECT_RAIDTARGET6 = COMBATLOG_OBJECT_RAIDTARGET6
local COMBATLOG_OBJECT_RAIDTARGET7 = COMBATLOG_OBJECT_RAIDTARGET7
local COMBATLOG_OBJECT_RAIDTARGET8 = COMBATLOG_OBJECT_RAIDTARGET8
local COMBATLOG_OBJECT_NONE = COMBATLOG_OBJECT_NONE
local COMBATLOG_OBJECT_SPECIAL_MASK = COMBATLOG_OBJECT_SPECIAL_MASK
local COMBATLOG_FILTER_ME = COMBATLOG_FILTER_ME
local COMBATLOG_FILTER_MINE = COMBATLOG_FILTER_MINE
local COMBATLOG_FILTER_MY_PET = COMBATLOG_FILTER_MY_PET
local COMBATLOG_FILTER_FRIENDLY_UNITS = COMBATLOG_FILTER_FRIENDLY_UNITS
local COMBATLOG_FILTER_HOSTILE_UNITS = COMBATLOG_FILTER_HOSTILE_UNITS
local COMBATLOG_FILTER_HOSTILE_PLAYERS = COMBATLOG_FILTER_HOSTILE_PLAYERS
local COMBATLOG_FILTER_NEUTRAL_UNITS = COMBATLOG_FILTER_NEUTRAL_UNITS
local COMBATLOG_FILTER_UNKNOWN_UNITS = COMBATLOG_FILTER_UNKNOWN_UNITS
local COMBATLOG_FILTER_EVERYTHING = COMBATLOG_FILTER_EVERYTHING
local COMBATLOG = COMBATLOG
local AURA_TYPE_BUFF = AURA_TYPE_BUFF
local AURA_TYPE_DEBUFF = AURA_TYPE_DEBUFF
local SPELL_POWER_MANA = SPELL_POWER_MANA
local SPELL_POWER_RAGE = SPELL_POWER_RAGE
local SPELL_POWER_FOCUS = SPELL_POWER_FOCUS
local SPELL_POWER_ENERGY = SPELL_POWER_ENERGY
local SPELL_POWER_HAPPINESS = SPELL_POWER_HAPPINESS
local SPELL_POWER_RUNES = SPELL_POWER_RUNES
local SPELL_POWER_RUNIC_POWER = SPELL_POWER_RUNIC_POWER
local SCHOOL_MASK_NONE = SCHOOL_MASK_NONE
local SCHOOL_MASK_PHYSICAL = SCHOOL_MASK_PHYSICAL
local SCHOOL_MASK_HOLY = SCHOOL_MASK_HOLY
local SCHOOL_MASK_FIRE = SCHOOL_MASK_FIRE
local SCHOOL_MASK_NATURE = SCHOOL_MASK_NATURE
local SCHOOL_MASK_FROST = SCHOOL_MASK_FROST
local SCHOOL_MASK_SHADOW = SCHOOL_MASK_SHADOW
local SCHOOL_MASK_ARCANE = SCHOOL_MASK_ARCANE
local COMBATLOG_LIMIT_PER_FRAME = COMBATLOG_LIMIT_PER_FRAME
local COMBATLOG_HIGHLIGHT_MULTIPLIER = COMBATLOG_HIGHLIGHT_MULTIPLIER
local COMBATLOG_DEFAULT_COLORS = COMBATLOG_DEFAULT_COLORS
local COMBATLOG_DEFAULT_SETTINGS = COMBATLOG_DEFAULT_SETTINGS
local COMBATLOG_ICON_RAIDTARGET1 = COMBATLOG_ICON_RAIDTARGET1
local COMBATLOG_ICON_RAIDTARGET2 = COMBATLOG_ICON_RAIDTARGET2
local COMBATLOG_ICON_RAIDTARGET3 = COMBATLOG_ICON_RAIDTARGET3
local COMBATLOG_ICON_RAIDTARGET4 = COMBATLOG_ICON_RAIDTARGET4
local COMBATLOG_ICON_RAIDTARGET5 = COMBATLOG_ICON_RAIDTARGET5
local COMBATLOG_ICON_RAIDTARGET6 = COMBATLOG_ICON_RAIDTARGET6
local COMBATLOG_ICON_RAIDTARGET7 = COMBATLOG_ICON_RAIDTARGET7
local COMBATLOG_ICON_RAIDTARGET8 = COMBATLOG_ICON_RAIDTARGET8
local COMBATLOG_EVENT_LIST = COMBATLOG_EVENT_LIST



--[[
      UTILITIES ----------------------------------------------------------------------------------------------------------------
  ]]

function HitsMode5:tcopy(to, from)
 for k, v in pairs(from) do
  if(type(v) == "table") then
   to[k] = {}
   HitsMode5:tcopy(to[k], v)
  else
   to[k] = v
  end
 end
end

function boolToString(b)
	if b == true then return "true" end
	if b == false then return "false" end
	if b == nil then return "nil" end
end



--[[
      INITIALIZATION -----------------------------------------------------------------------------------------------------------
  ]]

function HitsMode5:OnInitialize()
	-- Register database
 self.db = LibStub("AceDB-3.0"):New("HitsMode5DB", self.defaults, "Default")
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileDeleted", "OnProfileChanged")
	
	-- Register for slash commands
	self:RegisterChatCommand("hitsmode", "ChatCommand")
	self:RegisterChatCommand("hm", "ChatCommand")
end


function HitsMode5:OnEnable()
	if self.db.profile.enabled then

		-- Make sure the Blizzard Combat Log is loaded
		local result = LoadAddOn("Blizzard_CombatLog")
		if result ~= 1 then
			self:Print(format(L["Unable to load Blizzard Combat Log. HitsMode5 cannot be enabled. (Reason: %s)"], _G["ADDON_"..result]))
			self:Disable()
			return
		end
		
		-- Initialize settings
		self:UpgradeSettings()
		self:ReloadSettings()

		-- Register for events
		for k, v in pairs(specialEvents) do
			self:RegisterEvent(v, "OnSpecialEvent");
		end
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "OnCombatEvent")
	 
		-- Turn us on
		isEnabled = true

		--[===[@debug@
			self:Print(L["Loaded"])
		--@end-debug@]===]
		
	end
end


function HitsMode5:OnDisable()
	-- Unregister all events
	self:UnregisterAllEvents()

	-- Turn us off
	isEnabled = false
	
	--[===[@debug@
		self:Print(L["Disabled"])
	--@end-debug@]===]
end


function HitsMode5:ChatCommand(input)
	if not input or input:trim() == "" then
		if self.modules.options.loaded then InterfaceOptionsFrame_OpenToCategory(self.optionsFrame) end
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(HitsMode5, "hm", "HitsMode5", input)
	end
end


function HitsMode5:OnProfileChanged(event, database, newProfileKey)
	--[===[@debug@
		self:Print(L["Profile modified, rebooting"])
	--@end-debug@]===]
 self:Disable()
 self:Enable() 
end


--[[
      HELP SYSTEM --------------------------------------------------------------------------------------------------------------
  ]]

do
	local i
	for i = 1, NUM_HELPARTICLES do
		HelpLib.AddQuestion({
			q = L["help_question_"..i],
			a = L["help_answer_"..i],
			cat = "HitsMode5",
		});
	end
end

function HitsMode5:CheckHelpLoaded()
 if (KBSetup_IsLoaded()) then
  KnowledgeBaseFrameEditBox:SetText("")
  UIDropDownMenu_SetSelectedName(KnowledgeBaseFrameCategoryDropDown, "HitsMode5")
  KnowledgeBaseFrame_Search(1)
 else
		self:ScheduleTimer("CheckHelpLoaded", 0.2)
 end
end



--[[
      FILTERS ------------------------------------------------------------------------------------------------------------------
  ]]

-- Filter prototype
HitsMode5.Filter = {}
local mt = {__index = HitsMode5.Filter}


function HitsMode5.Filter:new()
 return setmetatable({
		someproperty = 1
 }, mt)
end


function HitsMode5.Filter:destroy()
	-- Destroy a filter
end


function HitsMode5.Filter:UpdateFlags()
	self.sourceFlags = 0
	for k, v in pairs(self.db.sourceFlags) do
		if v then self.sourceFlags = self.sourceFlags + k end
	end
	self.destFlags = 0
	for k, v in pairs(self.db.destFlags) do
		if v then self.destFlags = self.destFlags + k end
	end
end


local function stringToArray(s)
	local hasMembers = false
	local a = { strsplit(",", s) }
	local b = {}
	for k, v in pairs(a) do
		if strtrim(v) ~= "" then
			b[strlower(strtrim(v))] = true
			hasMembers = true
		end
	end
	return b, hasMembers
end


function HitsMode5.Filter:UpdateWhiteBlackLists()
	self.sourceNameWhiteList, self.sourceNameWhiteListEnabled = stringToArray(self.db.sourceWhiteList)
	self.sourceNameBlackList, self.sourceNameBlackListEnabled = stringToArray(self.db.sourceBlackList)
	self.destNameWhiteList, self.destNameWhiteListEnabled = stringToArray(self.db.destWhiteList)
	self.destNameBlackList, self.destNameBlackListEnabled = stringToArray(self.db.destBlackList)
end


function HitsMode5:GetFilters()
	return filters
end


function HitsMode5:CreateFilter(name, db)
	if not db then
		db = {}
		self:tcopy(db, self.filterDefaults)
		table.insert(self.db.profile.filters, db)
	end

	local filter = HitsMode5.Filter:new()
	filter.db = db
	filter.db.name = name
	
	table.insert(filters, filter)
	
	if self.modules.options.loaded then filter:AddOptions() end
	filter:UpdateFlags()
	filter:UpdateWhiteBlackLists()
	self:ApplySettings()
end


function HitsMode5:DeleteFilter(name)
	for k, v in ipairs(filters) do
		if v.db.name == name then
			v:destroy()
			wipe(table.remove(filters, k))
		end
	end
	for k, v in ipairs(self.db.profile.filters) do
		if v.name == name then
			table.remove(self.db.profile.filters, k)
		end
	end
	HitsMode5.options.args.filters.args[name] = nil
end



--[[
      SETTINGS -----------------------------------------------------------------------------------------------------------------
  ]]
  
function HitsMode5:UpgradeSettings()
	-- Placeholder function in case we have to do some tricky options upgrading in the future
	-- For now, just keep track of the version we used last
	self.db.profile.lastVersion = self.db.profile.currentVersion or self.MINOR_VERSION
	self.db.profile.currentVersion = self.MINOR_VERSION
end

function HitsMode5:ReloadSettings()
	for k, v in ipairs(filters) do
		v:destroy()
	end
	filters = {}

	for k, v in ipairs(self.db.profile.filters) do
		self:CreateFilter(v.name, v)
	end
	
	self:ApplySettings()
end


function HitsMode5:ApplySettings()
end


--[[
      EVENTS -------------------------------------------------------------------------------------------------------------------
  ]]

function HitsMode5:OnSpecialEvent(event, ...)
 if (isEnabled) then
		--
 end
end


function HitsMode5:OnCombatEvent(event, ...)
 if (isEnabled) then
		self:Render(false, ...)
 end
end


--[[
      RENDERER -----------------------------------------------------------------------------------------------------------------
  ]]
  
function HitsMode5:FormatExtraValues(resisted, blocked, absorbed, critical, glancing, crushing, overhealing, spellId, overkill)
	local resultStr
	local useOverhealing = overhealing and overhealing > 0
	local useOverkill = overkill and overkill > 0
	local useAbsorbed = absorbed and absorbed > 0
	
	if (resisted or blocked or critical or glancing or crushing or useOverhealing or useOverkill or useAbsorbed) then
		resultStr = nil
		
		if (resisted) then
			if (resisted < 0) then	-- It's really a vulnerability
				resultStr = format(TEXT_MODE_A_STRING_RESULT_VULNERABILITY, -resisted)
			else
				resultStr = format(TEXT_MODE_A_STRING_RESULT_RESIST, resisted)
			end
		end
		if (blocked) then
			if (resultStr) then
				resultStr = resultStr.." "..format(TEXT_MODE_A_STRING_RESULT_BLOCK, blocked)
			else
				resultStr = format(TEXT_MODE_A_STRING_RESULT_BLOCK, blocked)
			end
		end
		if (useAbsorbed) then
			if (resultStr) then
				resultStr = resultStr.." "..format(TEXT_MODE_A_STRING_RESULT_ABSORB, absorbed)
			else
				resultStr = format(TEXT_MODE_A_STRING_RESULT_ABSORB, absorbed)
			end
		end
		if (glancing) then
			if (resultStr) then
				resultStr = resultStr.." "..TEXT_MODE_A_STRING_RESULT_GLANCING
			else
				resultStr = TEXT_MODE_A_STRING_RESULT_GLANCING
			end
		end
		if (crushing) then
			if (resultStr) then
				resultStr = resultStr.." "..TEXT_MODE_A_STRING_RESULT_CRUSHING
			else
				resultStr = TEXT_MODE_A_STRING_RESULT_CRUSHING
			end
		end
		if (useOverhealing) then
			if (resultStr) then
				resultStr = resultStr.." "..format(TEXT_MODE_A_STRING_RESULT_OVERHEALING, overhealing)
			else
				resultStr = format(TEXT_MODE_A_STRING_RESULT_OVERHEALING, overhealing)
			end
		end
		if (useOverkill) then
			if (resultStr) then
				resultStr = resultStr.." "..format(TEXT_MODE_A_STRING_RESULT_OVERKILLING, overkill)
			else
				resultStr = format(TEXT_MODE_A_STRING_RESULT_OVERKILLING, overkill)
			end
		end
		if (critical) then
			local critString = TEXT_MODE_A_STRING_RESULT_CRITICAL
			if (spellId) then
				critString = TEXT_MODE_A_STRING_RESULT_CRITICAL_SPELL
			end
			if (resultStr) then
				resultStr = resultStr.." "..critString
			else
				resultStr = critString
			end
		end
	end

	return resultStr
end


local function colorize(s, color)
	if color then
		return string.format("|cff%02x%02x%02x%s|r", (color.r or 1) * 255, (color.g or 1) * 255, (color.b or 1) * 255, s)
	else
		return s
	end
end

function HitsMode5:ChooseUnitColor(flags)
	if CombatLog_Object_IsA(flags, COMBATLOG_FILTER_ME) then return self.db.profile.colors.unitNames.you
	elseif CombatLog_Object_IsA(flags, COMBATLOG_FILTER_MY_PET) then return self.db.profile.colors.unitNames.pet
	elseif CombatLog_Object_IsA(flags, COMBATLOG_FILTER_FRIENDLY_UNITS) then return self.db.profile.colors.unitNames.friends
	elseif CombatLog_Object_IsA(flags, COMBATLOG_FILTER_HOSTILE_UNITS) then return self.db.profile.colors.unitNames.hostileUnits
	elseif CombatLog_Object_IsA(flags, COMBATLOG_FILTER_HOSTILE_PLAYERS) then return self.db.profile.colors.unitNames.hostilePlayers
	elseif CombatLog_Object_IsA(flags, COMBATLOG_FILTER_NEUTRAL_UNITS) then return self.db.profile.colors.unitNames.neutral
	else return self.db.profile.colors.unitNames.unknown
	end
end


function HitsMode5:Render(isReplay, timestamp, eventType, srcGuid, srcName, srcFlags, dstGuid, dstName, dstFlags, ...)

	-- Variables
	local spellId, spellName, spellSchool
	local extraSpellId, extraSpellName, extraSpellSchool
	local nameIsNotSpell, extraNameIsNotSpell
	local amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, overhealing
	local missType, amountMissed
	local auraType
	local itemId, itemName
	local valueType = 1  -- 1 = School, 2 = Power Type
	local extraAmount
	local powerType
	local environmentalType
	local finalString, messageFormat, formatType, extra, forEnabled
	local srcNameLower = strlower(srcName or "")
	local dstNameLower = strlower(dstName or "")
	local action
	local srcNameStr, dstNameStr


	-- Loop through all filters
	for filterKey, f in pairs(filters) do
	
		-- Filter enabled
		if f.db.enabled then
			
			-- Hash lookup to see if the combat event is needed
			if f.db.events[eventType] then
			
				-- Use the prebuilt flag bitfields to quickly check if the event passes the filter
				-- This comparison is entirely in C, so it should be speedy
				if CombatLog_Object_IsA(srcFlags, f.sourceFlags) and CombatLog_Object_IsA(dstFlags, f.destFlags) then
				
					-- Use prebuilt hash lookups to see if the units pass the black/white lists
					if ((f.sourceNameWhiteListEnabled and f.sourceNameWhiteList[srcNameLower]) or f.sourceNameWhiteListEnabled == false or srcNameLower == "") and
								((f.sourceNameBlackListEnabled and f.sourceNameBlackList[srcNameLower] == nil) or f.sourceNameBlackListEnabled == false or srcNameLower == "") and
								((f.destNameWhiteListEnabled and f.destNameWhiteList[dstNameLower]) or f.destNameWhiteListEnabled == false or dstNameLower == "") and
								((f.destNameBlackListEnabled and f.destNameBlackList[dstNameLower] == nil) or f.destNameBlackListEnabled == false or dstNameLower == "")
					then
					
						-- Get what we need from the event, and prepare our presentation
						
						if eventType == "RANGE_DAMAGE" or eventType == "SPELL_DAMAGE" or eventType == "SPELL_PERIODIC_DAMAGE" or eventType == "DAMAGE_SHIELD" or eventType == "DAMAGE_SPLIT" or eventType == "SPELL_BUILDING_DAMAGE" then
							spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(1, ...)
							formatType = "A"
							action = L["hit"]
							forEnabled = true
							if f.db.display.includeExtraValues then
								extra = self:FormatExtraValues(resisted, blocked, absorbed, critical, glancing, crushing, overhealing, spellId, overkill)
							end

						elseif eventType == "SWING_DAMAGE" then
							amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(1, ...)
							
						elseif eventType == "SPELL_HEAL" or eventType == "SPELL_PERIODIC_HEAL" or eventType == "SPELL_BUILDING_HEAL" then
							spellId, spellName, spellSchool, amount, overhealing, absorbed, critical = select(1, ...)
							
						elseif eventType == "SPELL_ENERGIZE" or eventType == "SPELL_PERIODIC_ENERGIZE" then
							spellId, spellName, spellSchool, amount, powerType = select(1, ...)
							
						elseif eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_REFRESH" or eventType == "SPELL_AURA_REMOVED" then
							spellId, spellName, spellSchool, auraType = select(1, ...)
							
						elseif eventType == "SPELL_AURA_APPLIED_DOSE" or eventType == "SPELL_AURA_REMOVED_DOSE" then
							spellId, spellName, spellSchool, auraType, amount = select(1, ...)
							
						elseif eventType == "RANGE_MISSED" or eventType == "SPELL_MISSED" or eventType == "SPELL_PERIODIC_MISSED" or eventType == "DAMAGE_SHIELD_MISSED" then
							spellId, spellName, spellSchool, missType, amountMissed = select(1, ...)
							
						elseif eventType == "SWING_MISSED" then
							missType, amountMissed = select(1, ...)
							
						elseif eventType == "SPELL_DRAIN" or eventType == "SPELL_PERIODIC_DRAIN" then
							spellId, spellName, spellSchool, amount, powerType, extraAmount = select(1, ...)
							
						elseif eventType == "SPELL_LEECH" or eventType == "SPELL_PERIODIC_LEECH" then
							-- Amount is the gain for the source and extraAmount is the loss for the dest
							spellId, spellName, spellSchool, amount, powerType, extraAmount = select(1, ...)
		 
						elseif eventType == "SPELL_EXTRA_ATTACKS" then
							spellId, spellName, spellSchool, amount = select(1, ...)
							
						elseif eventType == "SPELL_DISPEL" then
							-- The first spell is the one causing the aura to be dispelled or otherwise cancelled, and the second is the name of the aura that is being dispelled
							extraSpellId, extraSpell, extraSpellSchool, spellId, spellName, spellSchool, auraType = select(1, ...)

						elseif eventType == "SPELL_STOLEN" then
							-- First spell is the one that caused the spell steal. Second spell is the spell that was stolen.
							extraSpellId, extraSpell, extraSpellSchool, spellId, spellName, spellSchool, auraType = select(1, ...)

						elseif eventType == "SPELL_AURA_BROKEN" then
							spellId, spellName, spellSchool, auraType = select(1, ...)
							
						elseif eventType == "SPELL_AURA_BROKEN_SPELL" then
							-- Source is the person breaking crowd control
							-- Dest is the person who was being crowd controlled
							-- Spell is the crowd control spell
							-- ExtraSpell is the spell that broke it
							spellId, spellName, spellSchool, extraSpellId, extraSpell, extraSpellSchool, auraType = select(1, ...)

						elseif eventType == "ENVIRONMENTAL_DAMAGE" then
							environmentalType, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(1, ...)
						
						elseif eventType == "SPELL_INTERRUPT" then
							-- SpellName does the interrupting, extraSpellName is what gets interrupted
							extraSpellId, extraSpell, extraSpellSchool, spellId, spellName, spellSchool = select(1, ...)

						elseif eventType == "SPELL_CAST_START" then
							spellId, spellName, spellSchool = select(1, ...)
							
						elseif eventType == "SPELL_CAST_SUCCESS" then
							spellId, spellName, spellSchool = select(1, ...)
							
						elseif eventType == "SPELL_CAST_FAILED" then
							spellId, spellName, spellSchool, missType = select(1, ...)
							
						elseif eventType == "SPELL_DISPEL_FAILED" then
							spellId, spellName, spellSchool, extraSpellId, extraSpellName, extraSpellSchool = select(1, ...)
							
						elseif eventType == "SPELL_INSTAKILL" then
							spellId, spellName, spellSchool = select(1, ...)
							
						elseif eventType == "PARTY_KILL" then
							-- No other parameters other than source/dest
							
						elseif eventType == "UNIT_DIED" or eventType == "UNIT_DISSIPATES" then
							-- No other parameters other than source/dest
							
						elseif eventType == "UNIT_DESTROYED" then
							-- No other parameters other than source/dest
							
						elseif eventType == "SPELL_SUMMON" or eventType == "SPELL_CREATE" or eventType == "SPELL_RESURRECT" then
							spellId, spellName, spellSchool = select(1, ...)
							
						elseif eventType == "ENCHANT_APPLIED" or eventType == "ENCHANT_REMOVED" then
							spellName, itemId, itemName = select(1, ...)
							
						elseif eventType == "SPELL_DURABILITY_DAMAGE" or eventType == "SPELL_DURABILITY_DAMAGE_ALL" then
							spellId, spellName, spellSchool = select(1, ...)
							
						end
						
						
						
						
						
						-- "$source $spell $action $dest $for $amount $extra"
					
					
					
						------[[ Setup and colorize the units ]]-------------------------------------------------------------------------------------
						
						srcNameStr = srcName
						dstNameStr = dstName
						
						-- Apply the possessive form to the source
						if srcName and spellName and _G["ACTION_"..eventType.."_POSSESSIVE"] == "1" then
							srcNameStr = format(TEXT_MODE_A_STRING_POSSESSIVE, srcNameStr)
						end

						-- Apply the possessive form to the dest if the dest has a spell
						if (extraSpellName or itemName) and dstName then
							dstNameStr = format(TEXT_MODE_A_STRING_POSSESSIVE, dstNameStr)
						end
						
						-- Colorize
						srcNameStr = colorize(srcNameStr, self:ChooseUnitColor(srcFlags))
						dstNameStr = colorize(dstNameStr, self:ChooseUnitColor(dstFlags))
						
						-- Bracketize
						if f.db.display.nameBrackets then
							srcNameStr = format("%s%s%s", colorize("[", self.db.profile.colors.general.brackets), srcNameStr, colorize("]", self.db.profile.colors.general.brackets))
							dstNameStr = format("%s%s%s", colorize("[", self.db.profile.colors.general.brackets), dstNameStr, colorize("]", self.db.profile.colors.general.brackets))
						end


						------[[ Final message setup ]]----------------------------------------------------------------------------------------------
						
						if formatType then
							
							messageFormat = L[formats[f.db.display.displayMode].."_"..formatType]
							finalString = strreplace(messageFormat, "$source", srcNameStr or "")
							finalString = strreplace(finalString, "$dest", dstNameStr or "")
							finalString = strreplace(finalString, "$spell", spellName or "")
							finalString = strreplace(finalString, "$action", action or "")
							if forEnabled and f.db.display.includeFor then
								finalString = strreplace(finalString, "$for", L["for"])
							else
								finalString = strreplace(finalString, "$for", "")
							end
							finalString = strreplace(finalString, "$amount", amount or "")
							finalString = strreplace(finalString, "$extra", extra or "")
						
							-- Clean up the final string
							finalString = gsub(finalString, " [ ]+", " " ) -- Extra white spaces
							finalString = gsub(finalString, " ([.,])", "%1" ) -- Spaces before periods or comma
							finalString = gsub(finalString, "^([ .,]+)", "" ) -- Spaces, period or comma at the beginning of a line
							
							-- Colorize any leftover text
							finalString = colorize(finalString, self.db.profile.colors.general.text)
							
							
						------[[ Output the message ]]-----------------------------------------------------------------------------------------------
						
							_G[format("ChatFrame%d", f.db.display.chatWindow)]:AddMessage(finalString)
						
						end
										
						-- -- support for Blood Princes achievement
						-- if eventType == "SPELL_DAMAGE" or eventType == "SPELL_PERIODIC_DAMAGE" then
							-- spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(1, ...)
							-- if amount >= 23000 and bit_band(dstFlags, COMBATLOG_OBJECT_TYPE_PLAYER) == COMBATLOG_OBJECT_TYPE_PLAYER and school ~= SCHOOL_MASK_PHYSICAL then
								-- SendChatMessage(format("%s was hit for %d spell damage from %s's %s. Achievement failed.", dstName, amount, srcName, spellName), "RAID_WARNING")
							 -- --self:Print(format("src: %s dst: %s srcflags: %d dstflags: %d spell: %s", srcName, dstName, srcFlags, dstFlags, spellName))
							 -- self:Print(format("%s was hit for %d spell damage from %s's %s. Achievement failed.", dstName, amount, srcName, spellName))
							-- end
							-- amount = amount - (overkill or 0)
						-- end
					
							
					end -- unit name list check
				end -- unit flags check
			end -- event enabled check
		end -- filter enabled check
	end -- filter loop
	
end

